import{s as Me,n as Ie,o as Ae}from"../chunks/scheduler.defa9a21.js";import{S as Re,i as He,g as l,s as o,r as c,A as We,h as i,f as t,c as r,j as w,u as p,x,k as $,y as n,a as d,v as _,d as u,t as f,w as m}from"../chunks/index.fe795e71.js";import{D as R}from"../chunks/Docstring.07f3d703.js";import{H as Y,E as qe}from"../chunks/EditOnGithub.0f575778.js";function Ve(Ce){let b,Z,Q,ee,F,te,C,ae,y,T,he,H,Te="Enables RAM efficient loading of Hugging Face models for FSDP in the environment.",oe,N,re,v,k,be,W,Ne="Disables RAM efficient loading of Hugging Face models for FSDP in the environment.",ne,O,le,g,U,ye,q,ke=`Merge the weights from sharded FSDP model checkpoints into a single combined checkpoint. Should be used if
<code>SHARDED_STATE_DICT</code> was used for the model. Weights will be saved to <code>{output_path}/model.safetensors</code> if
<code>safe_serialization</code> else <code>pytorch_model.bin</code>.`,ve,V,Oe="Note: this is a CPU-bound process.",ie,L,de,s,E,we,B,Ue="This plugin is used to enable fully sharded data parallelism.",$e,P,z,Pe,G,Le=`Given <code>model</code>, creates an <code>auto_wrap_policy</code> baesd on the passed in policy and if we can use the
<code>transformer_cls_to_wrap</code>`,Se,S,M,De,j,Ee="Sets the mixed precision policy for FSDP",xe,D,I,Fe,J,ze="Set the state dict config based on the <code>StateDictType</code>.",se,A,ce,X,pe;return F=new Y({props:{title:"Fully Sharded Data Parallel utilities",local:"fully-sharded-data-parallel-utilities",headingTag:"h1"}}),C=new Y({props:{title:"enable_fsdp_ram_efficient_loading",local:"accelerate.utils.enable_fsdp_ram_efficient_loading",headingTag:"h2"}}),T=new R({props:{name:"accelerate.utils.enable_fsdp_ram_efficient_loading",anchor:"accelerate.utils.enable_fsdp_ram_efficient_loading",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v1.3.0/src/accelerate/utils/fsdp_utils.py#L31"}}),N=new Y({props:{title:"disable_fsdp_ram_efficient_loading",local:"accelerate.utils.disable_fsdp_ram_efficient_loading",headingTag:"h2"}}),k=new R({props:{name:"accelerate.utils.disable_fsdp_ram_efficient_loading",anchor:"accelerate.utils.disable_fsdp_ram_efficient_loading",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v1.3.0/src/accelerate/utils/fsdp_utils.py#L41"}}),O=new Y({props:{title:"merge_fsdp_weights",local:"accelerate.utils.merge_fsdp_weights",headingTag:"h2"}}),U=new R({props:{name:"accelerate.utils.merge_fsdp_weights",anchor:"accelerate.utils.merge_fsdp_weights",parameters:[{name:"checkpoint_dir",val:": str"},{name:"output_path",val:": str"},{name:"safe_serialization",val:": bool = True"},{name:"remove_checkpoint_dir",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.utils.merge_fsdp_weights.checkpoint_dir",description:`<strong>checkpoint_dir</strong> (<code>str</code>) &#x2014;
The directory containing the FSDP checkpoints (can be either the model or optimizer).`,name:"checkpoint_dir"},{anchor:"accelerate.utils.merge_fsdp_weights.output_path",description:`<strong>output_path</strong> (<code>str</code>) &#x2014;
The path to save the merged checkpoint.`,name:"output_path"},{anchor:"accelerate.utils.merge_fsdp_weights.safe_serialization",description:`<strong>safe_serialization</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to save the merged weights with safetensors (recommended).`,name:"safe_serialization"},{anchor:"accelerate.utils.merge_fsdp_weights.remove_checkpoint_dir",description:`<strong>remove_checkpoint_dir</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to remove the checkpoint directory after merging.`,name:"remove_checkpoint_dir"}],source:"https://github.com/huggingface/accelerate/blob/v1.3.0/src/accelerate/utils/fsdp_utils.py#L275"}}),L=new Y({props:{title:"FullyShardedDataParallelPlugin",local:"accelerate.FullyShardedDataParallelPlugin",headingTag:"h2"}}),E=new R({props:{name:"class accelerate.FullyShardedDataParallelPlugin",anchor:"accelerate.FullyShardedDataParallelPlugin",parameters:[{name:"sharding_strategy",val:": typing.Union[str, ForwardRef('torch.distributed.fsdp.ShardingStrategy')] = None"},{name:"backward_prefetch",val:": typing.Union[str, ForwardRef('torch.distributed.fsdp.BackwardPrefetch')] = None"},{name:"mixed_precision_policy",val:": typing.Union[dict, ForwardRef('torch.distributed.fsdp.MixedPrecision'), NoneType] = None"},{name:"auto_wrap_policy",val:": typing.Union[typing.Callable, typing.Literal['transformer_based_wrap', 'size_based_wrap', 'no_wrap'], NoneType] = None"},{name:"cpu_offload",val:": typing.Union[bool, ForwardRef('torch.distributed.fsdp.CPUOffload')] = None"},{name:"ignored_modules",val:": typing.Optional[typing.Iterable[torch.nn.modules.module.Module]] = None"},{name:"state_dict_type",val:": typing.Union[str, ForwardRef('torch.distributed.fsdp.StateDictType')] = None"},{name:"state_dict_config",val:": typing.Union[ForwardRef('torch.distributed.fsdp.FullStateDictConfig'), ForwardRef('torch.distributed.fsdp.ShardedStateDictConfig'), NoneType] = None"},{name:"optim_state_dict_config",val:": typing.Union[ForwardRef('torch.distributed.fsdp.FullOptimStateDictConfig'), ForwardRef('torch.distributed.fsdp.ShardedOptimStateDictConfig'), NoneType] = None"},{name:"limit_all_gathers",val:": bool = True"},{name:"use_orig_params",val:": bool = None"},{name:"param_init_fn",val:": typing.Optional[typing.Callable[[torch.nn.modules.module.Module], NoneType]] = None"},{name:"sync_module_states",val:": bool = None"},{name:"forward_prefetch",val:": bool = None"},{name:"activation_checkpointing",val:": bool = None"},{name:"cpu_ram_efficient_loading",val:": bool = None"},{name:"transformer_cls_names_to_wrap",val:": typing.Optional[typing.List[str]] = None"},{name:"min_num_params",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"accelerate.FullyShardedDataParallelPlugin.sharding_strategy",description:`<strong>sharding_strategy</strong> (<code>Union[str, torch.distributed.fsdp.ShardingStrategy]</code>, defaults to <code>&apos;FULL_SHARD&apos;</code>) &#x2014;
Sharding strategy to use. Should be either a <code>str</code> or an instance of
<code>torch.distributed.fsdp.fully_sharded_data_parallel.ShardingStrategy</code>.`,name:"sharding_strategy"},{anchor:"accelerate.FullyShardedDataParallelPlugin.backward_prefetch",description:`<strong>backward_prefetch</strong> (<code>Union[str, torch.distributed.fsdp.BackwardPrefetch]</code>, defaults to <code>&apos;NO_PREFETCH&apos;</code>) &#x2014;
Backward prefetch strategy to use. Should be either a <code>str</code> or an instance of
<code>torch.distributed.fsdp.fully_sharded_data_parallel.BackwardPrefetch</code>.`,name:"backward_prefetch"},{anchor:"accelerate.FullyShardedDataParallelPlugin.mixed_precision_policy",description:`<strong>mixed_precision_policy</strong> (<code>Optional[Union[dict, torch.distributed.fsdp.MixedPrecision]]</code>, defaults to <code>None</code>) &#x2014;
A config to enable mixed precision training with FullyShardedDataParallel. If passing in a <code>dict</code>, it
should have the following keys: <code>param_dtype</code>, <code>reduce_dtype</code>, and <code>buffer_dtype</code>.`,name:"mixed_precision_policy"},{anchor:"accelerate.FullyShardedDataParallelPlugin.auto_wrap_policy",description:"<strong>auto_wrap_policy</strong> (<code>Optional(Union[Callable, Literal[&quot;transformer_based_wrap&quot;, &quot;size_based_wrap&quot;, &quot;no_wrap&quot;]]), defaults to </code>NO_WRAP<code>) -- A callable or string specifying a policy to recursively wrap layers with FSDP. If a string, it must be one of </code>transformer_based_wrap<code>, </code>size_based_wrap<code>, or </code>no_wrap<code>. See </code>torch.distributed.fsdp.wrap.size_based_wrap_policy` for a direction on what it should look like.",name:"auto_wrap_policy"},{anchor:"accelerate.FullyShardedDataParallelPlugin.cpu_offload",description:`<strong>cpu_offload</strong> (<code>Union[bool, torch.distributed.fsdp.CPUOffload]</code>, defaults to <code>False</code>) &#x2014;
Whether to offload parameters to CPU. Should be either a <code>bool</code> or an instance of
<code>torch.distributed.fsdp.fully_sharded_data_parallel.CPUOffload</code>.`,name:"cpu_offload"},{anchor:"accelerate.FullyShardedDataParallelPlugin.ignored_modules",description:`<strong>ignored_modules</strong> (<code>Optional[Iterable[torch.nn.Module]]</code>, defaults to <code>None</code>) &#x2014;
A list of modules to ignore when wrapping with FSDP.`,name:"ignored_modules"},{anchor:"accelerate.FullyShardedDataParallelPlugin.state_dict_type",description:`<strong>state_dict_type</strong> (<code>Union[str, torch.distributed.fsdp.StateDictType]</code>, defaults to <code>&apos;FULL_STATE_DICT&apos;</code>) &#x2014;
State dict type to use. If a string, it must be one of <code>full_state_dict</code>, <code>local_state_dict</code>, or
<code>sharded_state_dict</code>.`,name:"state_dict_type"},{anchor:"accelerate.FullyShardedDataParallelPlugin.state_dict_config",description:`<strong>state_dict_config</strong> (<code>Optional[Union[torch.distributed.fsdp.FullStateDictConfig, torch.distributed.fsdp.ShardedStateDictConfig]</code>, defaults to <code>None</code>) &#x2014;
State dict config to use. Is determined based on the <code>state_dict_type</code> if not passed in.`,name:"state_dict_config"},{anchor:"accelerate.FullyShardedDataParallelPlugin.optim_state_dict_config",description:`<strong>optim_state_dict_config</strong> (<code>Optional[Union[torch.distributed.fsdp.FullOptimStateDictConfig, torch.distributed.fsdp.ShardedOptimStateDictConfig]</code>, defaults to <code>None</code>) &#x2014;
Optim state dict config to use. Is determined based on the <code>state_dict_type</code> if not passed in.`,name:"optim_state_dict_config"},{anchor:"accelerate.FullyShardedDataParallelPlugin.limit_all_gathers",description:`<strong>limit_all_gathers</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to have FSDP explicitly synchronizes the CPU thread to prevent too many in-flight all-gathers. This
bool only affects the sharded strategies that schedule all-gathers. Enabling this can help lower the number
of CUDA malloc retries.`,name:"limit_all_gathers"},{anchor:"accelerate.FullyShardedDataParallelPlugin.use_orig_params",description:`<strong>use_orig_params</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the original parameters for the optimizer.`,name:"use_orig_params"},{anchor:"accelerate.FullyShardedDataParallelPlugin.param_init_fn",description:`<strong>param_init_fn</strong> (<code>Optional[Callable[[torch.nn.Module], None]</code>, defaults to <code>None</code>) &#x2014;
A <code>Callable[torch.nn.Module] -&gt; None</code> that specifies how modules that are currently on the meta device
should be initialized onto an actual device. Only applicable when <code>sync_module_states</code> is <code>True</code>. By
default is a <code>lambda</code> which calls <code>to_empty</code> on the module.`,name:"param_init_fn"},{anchor:"accelerate.FullyShardedDataParallelPlugin.sync_module_states",description:`<strong>sync_module_states</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether each individually wrapped FSDP unit should broadcast module parameters from rank 0 to ensure they
are the same across all ranks after initialization. Defaults to <code>False</code> unless <code>cpu_ram_efficient_loading</code>
is <code>True</code>, then will be forcibly enabled.`,name:"sync_module_states"},{anchor:"accelerate.FullyShardedDataParallelPlugin.forward_prefetch",description:`<strong>forward_prefetch</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to have FSDP explicitly prefetches the next upcoming all-gather while executing in the forward
pass. only use with Static graphs.`,name:"forward_prefetch"},{anchor:"accelerate.FullyShardedDataParallelPlugin.activation_checkpointing",description:`<strong>activation_checkpointing</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
A technique to reduce memory usage by clearing activations of certain layers and recomputing them during a
backward pass. Effectively, this trades extra computation time for reduced memory usage.`,name:"activation_checkpointing"},{anchor:"accelerate.FullyShardedDataParallelPlugin.cpu_ram_efficient_loading",description:`<strong>cpu_ram_efficient_loading</strong> (<code>bool</code>, defaults to <code>None</code>) &#x2014;
If True, only the first process loads the pretrained model checkoint while all other processes have empty
weights. Only applicable for Transformers. When using this, <code>sync_module_states</code> needs to be <code>True</code>.`,name:"cpu_ram_efficient_loading"},{anchor:"accelerate.FullyShardedDataParallelPlugin.transformer_cls_names_to_wrap",description:`<strong>transformer_cls_names_to_wrap</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
A list of transformer layer class names to wrap. Only applicable when <code>auto_wrap_policy</code> is
<code>transformer_based_wrap</code>.`,name:"transformer_cls_names_to_wrap"},{anchor:"accelerate.FullyShardedDataParallelPlugin.min_num_params",description:`<strong>min_num_params</strong> (<code>Optional[int]</code>, defaults to <code>None</code>) &#x2014;
The minimum number of parameters a module must have to be wrapped. Only applicable when <code>auto_wrap_policy</code>
is <code>size_based_wrap</code>.`,name:"min_num_params"}],source:"https://github.com/huggingface/accelerate/blob/v1.3.0/src/accelerate/utils/dataclasses.py#L1403"}}),z=new R({props:{name:"set_auto_wrap_policy",anchor:"accelerate.FullyShardedDataParallelPlugin.set_auto_wrap_policy",parameters:[{name:"model",val:""}],source:"https://github.com/huggingface/accelerate/blob/v1.3.0/src/accelerate/utils/dataclasses.py#L1737"}}),M=new R({props:{name:"set_mixed_precision",anchor:"accelerate.FullyShardedDataParallelPlugin.set_mixed_precision",parameters:[{name:"mixed_precision",val:""},{name:"buffer_autocast",val:" = False"},{name:"override",val:" = False"}],source:"https://github.com/huggingface/accelerate/blob/v1.3.0/src/accelerate/utils/dataclasses.py#L1768"}}),I=new R({props:{name:"set_state_dict_type",anchor:"accelerate.FullyShardedDataParallelPlugin.set_state_dict_type",parameters:[{name:"state_dict_type",val:" = None"}],source:"https://github.com/huggingface/accelerate/blob/v1.3.0/src/accelerate/utils/dataclasses.py#L1701"}}),A=new qe({props:{source:"https://github.com/huggingface/accelerate/blob/main/docs/source/package_reference/fsdp.md"}}),{c(){b=l("meta"),Z=o(),Q=l("p"),ee=o(),c(F.$$.fragment),te=o(),c(C.$$.fragment),ae=o(),y=l("div"),c(T.$$.fragment),he=o(),H=l("p"),H.textContent=Te,oe=o(),c(N.$$.fragment),re=o(),v=l("div"),c(k.$$.fragment),be=o(),W=l("p"),W.textContent=Ne,ne=o(),c(O.$$.fragment),le=o(),g=l("div"),c(U.$$.fragment),ye=o(),q=l("p"),q.innerHTML=ke,ve=o(),V=l("p"),V.textContent=Oe,ie=o(),c(L.$$.fragment),de=o(),s=l("div"),c(E.$$.fragment),we=o(),B=l("p"),B.textContent=Ue,$e=o(),P=l("div"),c(z.$$.fragment),Pe=o(),G=l("p"),G.innerHTML=Le,Se=o(),S=l("div"),c(M.$$.fragment),De=o(),j=l("p"),j.textContent=Ee,xe=o(),D=l("div"),c(I.$$.fragment),Fe=o(),J=l("p"),J.innerHTML=ze,se=o(),c(A.$$.fragment),ce=o(),X=l("p"),this.h()},l(e){const a=We("svelte-u9bgzb",document.head);b=i(a,"META",{name:!0,content:!0}),a.forEach(t),Z=r(e),Q=i(e,"P",{}),w(Q).forEach(t),ee=r(e),p(F.$$.fragment,e),te=r(e),p(C.$$.fragment,e),ae=r(e),y=i(e,"DIV",{class:!0});var _e=w(y);p(T.$$.fragment,_e),he=r(_e),H=i(_e,"P",{"data-svelte-h":!0}),x(H)!=="svelte-1lsbcnp"&&(H.textContent=Te),_e.forEach(t),oe=r(e),p(N.$$.fragment,e),re=r(e),v=i(e,"DIV",{class:!0});var ue=w(v);p(k.$$.fragment,ue),be=r(ue),W=i(ue,"P",{"data-svelte-h":!0}),x(W)!=="svelte-o9zxg8"&&(W.textContent=Ne),ue.forEach(t),ne=r(e),p(O.$$.fragment,e),le=r(e),g=i(e,"DIV",{class:!0});var K=w(g);p(U.$$.fragment,K),ye=r(K),q=i(K,"P",{"data-svelte-h":!0}),x(q)!=="svelte-lbcivn"&&(q.innerHTML=ke),ve=r(K),V=i(K,"P",{"data-svelte-h":!0}),x(V)!=="svelte-s693kt"&&(V.textContent=Oe),K.forEach(t),ie=r(e),p(L.$$.fragment,e),de=r(e),s=i(e,"DIV",{class:!0});var h=w(s);p(E.$$.fragment,h),we=r(h),B=i(h,"P",{"data-svelte-h":!0}),x(B)!=="svelte-da89af"&&(B.textContent=Ue),$e=r(h),P=i(h,"DIV",{class:!0});var fe=w(P);p(z.$$.fragment,fe),Pe=r(fe),G=i(fe,"P",{"data-svelte-h":!0}),x(G)!=="svelte-i24l23"&&(G.innerHTML=Le),fe.forEach(t),Se=r(h),S=i(h,"DIV",{class:!0});var me=w(S);p(M.$$.fragment,me),De=r(me),j=i(me,"P",{"data-svelte-h":!0}),x(j)!=="svelte-1oofbyv"&&(j.textContent=Ee),me.forEach(t),xe=r(h),D=i(h,"DIV",{class:!0});var ge=w(D);p(I.$$.fragment,ge),Fe=r(ge),J=i(ge,"P",{"data-svelte-h":!0}),x(J)!=="svelte-1ugzx3"&&(J.innerHTML=ze),ge.forEach(t),h.forEach(t),se=r(e),p(A.$$.fragment,e),ce=r(e),X=i(e,"P",{}),w(X).forEach(t),this.h()},h(){$(b,"name","hf:doc:metadata"),$(b,"content",Be),$(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(s,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){n(document.head,b),d(e,Z,a),d(e,Q,a),d(e,ee,a),_(F,e,a),d(e,te,a),_(C,e,a),d(e,ae,a),d(e,y,a),_(T,y,null),n(y,he),n(y,H),d(e,oe,a),_(N,e,a),d(e,re,a),d(e,v,a),_(k,v,null),n(v,be),n(v,W),d(e,ne,a),_(O,e,a),d(e,le,a),d(e,g,a),_(U,g,null),n(g,ye),n(g,q),n(g,ve),n(g,V),d(e,ie,a),_(L,e,a),d(e,de,a),d(e,s,a),_(E,s,null),n(s,we),n(s,B),n(s,$e),n(s,P),_(z,P,null),n(P,Pe),n(P,G),n(s,Se),n(s,S),_(M,S,null),n(S,De),n(S,j),n(s,xe),n(s,D),_(I,D,null),n(D,Fe),n(D,J),d(e,se,a),_(A,e,a),d(e,ce,a),d(e,X,a),pe=!0},p:Ie,i(e){pe||(u(F.$$.fragment,e),u(C.$$.fragment,e),u(T.$$.fragment,e),u(N.$$.fragment,e),u(k.$$.fragment,e),u(O.$$.fragment,e),u(U.$$.fragment,e),u(L.$$.fragment,e),u(E.$$.fragment,e),u(z.$$.fragment,e),u(M.$$.fragment,e),u(I.$$.fragment,e),u(A.$$.fragment,e),pe=!0)},o(e){f(F.$$.fragment,e),f(C.$$.fragment,e),f(T.$$.fragment,e),f(N.$$.fragment,e),f(k.$$.fragment,e),f(O.$$.fragment,e),f(U.$$.fragment,e),f(L.$$.fragment,e),f(E.$$.fragment,e),f(z.$$.fragment,e),f(M.$$.fragment,e),f(I.$$.fragment,e),f(A.$$.fragment,e),pe=!1},d(e){e&&(t(Z),t(Q),t(ee),t(te),t(ae),t(y),t(oe),t(re),t(v),t(ne),t(le),t(g),t(ie),t(de),t(s),t(se),t(ce),t(X)),t(b),m(F,e),m(C,e),m(T),m(N,e),m(k),m(O,e),m(U),m(L,e),m(E),m(z),m(M),m(I),m(A,e)}}}const Be='{"title":"Fully Sharded Data Parallel utilities","local":"fully-sharded-data-parallel-utilities","sections":[{"title":"enable_fsdp_ram_efficient_loading","local":"accelerate.utils.enable_fsdp_ram_efficient_loading","sections":[],"depth":2},{"title":"disable_fsdp_ram_efficient_loading","local":"accelerate.utils.disable_fsdp_ram_efficient_loading","sections":[],"depth":2},{"title":"merge_fsdp_weights","local":"accelerate.utils.merge_fsdp_weights","sections":[],"depth":2},{"title":"FullyShardedDataParallelPlugin","local":"accelerate.FullyShardedDataParallelPlugin","sections":[],"depth":2}],"depth":1}';function Ge(Ce){return Ae(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Xe extends Re{constructor(b){super(),He(this,b,Ge,Ve,Me,{})}}export{Xe as component};
